(function() {
  (function($) {
    var displayError, displayProducts, scriptLoc, scripts, widgetBaseUrl;
    scripts = document.getElementsByTagName('script');
    scriptLoc = scripts[scripts.length - 1].src;
    /^\./.exec(scriptLoc) ? (scriptLoc = /(.*\/)[^\/]*/.exec(document.location)[1] + scriptLoc) : null;
    widgetBaseUrl = /(.*\/widget)\//.exec(scriptLoc)[1];
    displayProducts = function(elem, prods, count) {
      var _a, _b, _c, _d, categories, lessElem, lessId, moreElem, moreId, prod, prodElems, prodId, rating;
      if (prods.error) {
        displayError(elem, prods.error.message || 'Unknown error.');
        return null;
      }
      categories = function() {
        var _a, _b, _c, _d, cat;
        _a = []; _c = prod.categoryPath.slice(1);
        for (_b = 0, _d = _c.length; _b < _d; _b++) {
          cat = _c[_b];
          _a.push(("<div class='bby-category'>" + (cat.name) + "</div>"));
        }
        return _a;
      };
      rating = function() {
        var rating, reviewCount, width;
        rating = parseFloat(prod.customerReviewAverage);
        reviewCount = parseInt(prod.customerReviewCount);
        if ((typeof rating !== "undefined" && rating !== null) && (typeof reviewCount !== "undefined" && reviewCount !== null) && reviewCount > 0) {
          width = Math.floor(rating * 20);
          return "<div class='bby-stars'><div class='bby-stars-fill' style='width: " + (width) + "%'></div></div> \
(" + (reviewCount) + "&nbsp;review" + ((reviewCount > 1) ? 's' : '') + ")";
        } else {
          return '';
        }
      };
      document.bbyProdId = 0;
      prodElems = (function() {
        _a = []; _c = prods.products.slice(0, count - 1 + 1);
        for (_b = 0, _d = _c.length; _b < _d; _b++) {
          prod = _c[_b];
          _a.push((function() {
            prodId = 'prod' + new Date().getTime() + '-' + document.bbyProdId++;
            lessId = ("bby-less-" + (prodId));
            moreId = ("bby-more-" + (prodId));
            lessElem = 'bbyJQuery("#' + lessId + '")';
            moreElem = 'bbyJQuery("#' + moreId + '")';
            return "<div class='bby-product'> \
<a href='" + (prod.cjAffiliateUrl || prod.url) + "' class='bby-thumbnail'><img src='" + (prod.thumbnailImage) + "'/></a> \
<div class='bby-header'> \
<div class='bby-buy-box'> \
<div class='bby-price'>$" + (prod.salePrice) + "</div> \
<a href='" + (prod.cjAffiliateAddToCartUrl || prod.addToCartUrl) + "' class='bby-add-to-cart'> \
<img src='" + (widgetBaseUrl) + "/images/btn_add_to_cart.gif'> \
</a> \
</div> \
<a href='" + (prod.cjAffiliateUrl || prod.url) + "' class='bby-title'>" + (prod.name) + "</a> \
<div class='bby-rating'> \
" + (rating()) + " \
</div> \
</div> \
<div class='bby-details'> \
<div class='bby-more-detail' id='" + (moreId) + "'> \
<div class='bby-categories'> \
" + (categories().join('&gt;')) + " \
</div> \
<div class='bby-description'> \
" + (prod.longDescriptionHtml || '') + " \
</div> \
<div class='bby-availability'> \
<div class='bby-availability-item'>" + (prod.onlineAvailabilityText) + "</div> \
<div class='bby-availability-item'>" + (prod.inStoreAvailabilityText) + "</div> \
</div> \
<div class='bby-disclosure-button bby-less' onclick='document.bbySlide(" + (lessElem) + ", true); document.bbySlide(" + (moreElem) + ", false)'></div> \
</div> \
<div class='bby-less-detail' id='" + (lessId) + "'> \
<div class='bby-disclosure-button bby-more' onclick='document.bbySlide(" + (lessElem) + ", false); document.bbySlide(" + (moreElem) + ", true)'></div> \
<div class='bby-description'> \
" + (prod.shortDescriptionHtml || '') + " \
</div> \
</div> \
</div> \
</div>";
          })());
        }
        return _a;
      })();
      if (prodElems.length) {
        elem.innerHTML = prodElems.join("<div class='bby-product-divider'></div>") + "<div style='clear:both'></div>";
        if (prodElems.length === 1) {
          $(elem).find('.bby-more-detail').show();
          return $(elem).find('.bby-less-detail').hide();
        }
      } else {
        return (elem.innerHTML = "<div class='bby-product'><div class='bby-title'>No products found.</div></div>");
      }
    };
    displayError = function(elem, message) {
      return (elem.innerHTML = ("<div class='bby-error'>Unable to load BBY widget:<br/><b>" + (message) + "</b></div>"));
    };
    document.bbyPopulateRemixWidgets = function() {
      var _a, _b, _c, _d, cssVersion, widgets;
      cssVersion = new Date().getTime();
      !(/^file:/.exec(widgetBaseUrl)) ? cssVersion /= 10 * 60 * 1000 : null;
      $("head").prepend(("<link rel='stylesheet' type='text/css' href='bbyopen.css?" + (cssVersion) + "'></link>"));
      widgets = $('.bby-remixwidget');
      _a = []; _c = widgets;
      for (_b = 0, _d = _c.length; _b < _d; _b++) {
        (function() {
          var apiKey, count, params, pid, query, sort, url;
          var widget = _c[_b];
          return _a.push((function() {
            apiKey = widget.getAttribute('bbyApiKey');
            query = widget.getAttribute('bbyQuery');
            sort = widget.getAttribute('bbySort') || 'salesRankMediumTerm.asc';
            count = parseInt(widget.getAttribute('bbyCount')) || 3;
            pid = widget.getAttribute('bbyPID');
            if (!(apiKey)) {
              return displayError(widget, "Missing bbyApiKey parameter. (<a href='http://remix.mashery.com/member/register'>Get an API key</a>)");
            } else {
              widget.innerHTML = ("<div class='bby-loading'><img src='" + (widgetBaseUrl) + "/images/loading.gif' width='16' height='16'>Loading...</div>");
              url = "http://api.remix.bestbuy.com/v1/products";
              if (query) {
                url += ("(" + query + ")");
              }
              params = {
                apiKey: apiKey,
                format: 'json',
                sort: sort,
                show: 'all'
              };
              if (pid) {
                params.PID = pid;
              }
              return $.ajax({
                url: url,
                data: params,
                dataType: 'jsonp',
                success: function(results) {
                  return displayProducts(widget, results, count);
                }
              });
            }
          })());
        })();
      }
      return _a;
    };
    document.bbySlide = function(el, show) {
      var height, visible;
      visible = el.is(":visible");
      if (show === visible) {
        return false;
      }
      height = el.data("originalHeight");
      if (!height) {
        height = el.show().height();
        el.data("originalHeight", height);
        if (!(visible)) {
          el.hide().css({
            height: 0
          });
        }
      }
      return show ? el.show().animate({
        height: height
      }, {
        duration: 300
      }) : el.animate({
        height: 0
      }, {
        duration: 300,
        complete: function() {
          return el.hide();
        }
      });
    };
    return $(document).ready(function() {
      if (!(document.bbyRemixLoaded)) {
        document.bbyRemixLoaded = true;
        return document.bbyPopulateRemixWidgets();
      }
    });
  })(bbyJQuery);
})();
